/* last reading s, for new file use it's head	*/
/*				 1994,5,5	*/
/* 1994,5,27 for sun */
/*  s(i)=(s(i)+f64)/f(i)           94.9	ignore bias		*/ 
/* 94,10,4 add *.fit */
/* 94,10,5 modify BZERO --> PZERO, BSCALE --> PSCALE */
/* 94,11,17 fitshead */
/* 95,3,28 add
    k=indexpos(head,"END     ");
    if(k==72)fread(flat,80,36,fp3);
 2013,4 add substract DARK*.fit
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#define   n      4096
char  head[72][80],dummy[36*80];
float flat[n*n],dark[n*n],a[n*n],f64,et;
FILE  *fp,*fp1;                         // fp1 for data_file
short ccd[n+64];
int   n1,n2,c1,c2,n11,n22,c11,c22;

main(int ac,char **av)
{
  int i,j,k,ki,kj;  char f1[40];
  if(ac<3){ printf("\n\t **** flaten *******\n");
 	    printf("\n\t                60222,  201304\n");
            printf("\n\tUsage:  flaten datafile flatfile   (for any size)\n");
            printf("\n\tShutter adjust:  (file in /vega2/rhbin)");
            printf("\n\t 20130221-20130417 use DARK130221-130417.fits");
            printf("\n\t 20130418-         use DARK130418-xxxxxx.fits");
            printf("\n\t if You donot want to adjust in the future,");
            printf(" just change 2nd_file's name\n\n");
            exit(0);
  }
// flat_file
  fp=fopen(av[2],"rb"); if(!fp){ printf("\t%s not found!\n",av[2]); exit(0);}
  fread(head,72,80,fp);
  k=indexpos(head,"END     ",72); if(k==72)fread(dummy,80,36,fp);
  fread(flat,n*n,4,fp); swap4(flat,n*n*4); fclose(fp);
  sscanf(&head[3][21],"%d",&n1); sscanf(&head[4][21],"%d",&n2); 
  if(n1!=n || n2!=n){ printf("\t%s not 4k*4k flat_file\n",av[2]); exit(0); }
  k=indexpos(head,"STATUS  ",72);
  if(k==72){ printf("\t%s not 4k*4k flat_file\n",av[2]); exit(0); }
  if(head[k][17]!='F'){printf("\t%s not 4k*4k flat_file\n",av[2]);exit(0);}
  k=indexpos(head,"CRVAL1   ",72);
  sscanf(&head[k][21],"%d",&c1); sscanf(&head[k+1][21],"%d",&c2); 
// data file
  fp1=fopen(av[1],"rb"); if(!fp){ printf("\t%s not found!\n",av[1]); exit(0);}
  fread(head,72,80,fp);
  k=indexpos(head,"END     ",72);
  if(k==72){ fread(dummy,80,36,fp1); strncpy(&head[71][0],"END     ",8); }
  sscanf(&head[1][21],"%d",&i); 
  if(i!=16){ printf("\t%s not a raw data file\n",av[1]); exit(0); }
  sscanf(&head[3][21],"%d",&n11); sscanf(&head[4][21],"%d",&n22); 
  k=indexpos(head,"CRVAL1   ",72);
  sscanf(&head[k][21],"%d",&c11); sscanf(&head[k+1][21],"%d",&c22); 
  k=indexpos(head,"BZERO   ",72); if(k==72)k=indexpos(head,"PZERO   ",72);
  sscanf(&head[k][20],"%f",&f64); 
// print
  printf("size: %d %d %d %d     %d %d %d %d\n",n1,n2,c1,c2,n11,n22,c11,c22);
  if(c11<c1 || c22<c2 || c11+n11>c1+n1 || c22+n22>c2+n2){
    printf("\tError: data frame out of FLAT frame !!!\n"); exit(0);
  }    
// dark;
  for(i=0;i<n*n;i++)dark[i]=0.;
  k=indexpos(head,"DATE-OBS",72);
  for(i=0;i<8;i++)f1[i]=head[k][i+21]; f1[i]=0; f1[2]=f1[5]=32;
  sscanf(f1,"%d %d %d",&i,&j,&k); k=k*10000+j*100+i;
if(k<140416){
  if(k>=130221){ strcpy(f1,"/vega2/rhbin/DARK130221-130417.fits");
    if(k>=130418)strcpy(f1,"/vega2/rhbin/DARK130418-xxxxxx.fits");
    fp=fopen(f1,"rb"); if(!fp)printf("\t%s not found! no DARK sdjust!\n",f1);
    else { 
      fseek(fp,72*80,0); fread(dark,n*n,4,fp); swap4(dark,n*n*4); fclose(fp);
      k=indexpos(head,"EXPOSURE",72); sscanf(&head[k][21],"%f",&et);
      et*=0.001; for(i=0;i<n*n;i++)dark[i]*=et;
      printf("I'll use %s to do shutter adjust!\n",f1); 
    }
  }  
}
// div
  kj=c11-c1;  k=0;
  for(i=0;i<n22;i++){
    fread(ccd,2,n11,fp1); swap2(ccd,2*n11);
    ki=(i+c22-c2)*n+kj;
     for(j=0;j<n11;j++) a[k++] =(ccd[j]+f64-dark[ki+j])/flat[ki+j];
  } fclose(fp1);
// write
  strcpy(f1,av[1]); f1[0]='p'; 
  strncpy(&head[1][27],"-32",3);	
  k=indexpos(head,"STATUS  ",72); strncpy(&head[k][11],"SUPER STAR",10);
  k=indexpos(head,"BZERO   ",72); if(k==72)k=indexpos(head,"PZERO   ",72);
  strncpy(&head[k][20],"  0.0000",8);
  fp=fopen(f1,"wb"); fwrite(head,80,72,fp); swap4(a,4*n11*n22);
  fwrite(a,4,n11*n22,fp); fclose(fp);
  printf("\t%s written !!\n",f1);
}
